#include <stdio.h>
#include <string.h>
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/sleep.h>
#include <avr/iocan128.h>
#include <avr/iocanxx.h>
#include <avr/signal.h>
#include "led.h"

/*Systemtakt= 5MHz*/
/* Berechnung Zeit zwischen 2 Overflows: 1/(Systemtakt) *(Vorteiler*256) */
/* Berechnung Overflows/Sekunde: (Systemtakt)/(256*Vorteiler) */
/*Vorteiler    Overflows/Sekunde      Zeit zwischen
                                     2 Overflows [s]

     1            19531.25         51.2exp(-6)      
     8            2441.40          409.6exp(-6) 
    64            305.17           3278.8exp(-6) 
   256            76.29            13107.2exp(-6) 
  1024            19.07            52428.8exp(-6) */




char tempstr[100];
	
char LED_print(char digit, char ASCII_data)
{
    
	char    Data_var;
	char tempstr[10];
  
	if( !digit == 1 )
		     
		return 0; 
	else
	{
		switch(ASCII_data )    //Find output pattern according to input
		{ 
			case    '0':    Data_var = 0x24;
			break;  
			case    '1':    Data_var = 0x3F;
			break;
			case    '2':    Data_var = 0x62;  
			break;
			case    '3':    Data_var = 0x2A;
			break;
			case    '4':    Data_var = 0xB1;  
			break;
			case    '5':    Data_var = 0xA8;
			break;
			case    '6':    Data_var = 0xA0;  
			break;
			case    '7':    Data_var = 0x3E;
			break;
			case    '8':    Data_var = 0x20;  
			break;
			case    '9':    Data_var = 0x38;
			break;
			case    'A':    Data_var = 0x30;
			break;
			case    'B':    Data_var = 0xA1;  
			break;
			case    'C':    Data_var = 0xE4;
			break;
			case    'D':    Data_var = 0x23;  
			break;
			case    'E':    Data_var = 0xE0;
			break;
			case    'F':    Data_var = 0xF0;
			break;
			
			default:        return 0; /* Returns 0 if input argument 
			ASCII_data is out of range */                  
		}
	}    
	if(digit == 1)
	{
		LED.digit1 = Data_var;             
		sprintf(tempstr, "digit1: 0x%x", LED.digit1); 		 break_point(tempstr, __LINE__);
	
		return 1;                           
	}
}


void LED_update(void)
{
	
	DDRC =  0xFF;
	PORTC = 0x00;
	PORTC = LED.digit1;                    //Writes outputs to segments
		
	sprintf(tempstr, "PortC:ausgang 0x%x", PORTC);
	break_point(tempstr, __LINE__);
	
	
	
}

ISR(SIG_OUTPUT_COMPARE1A)
{
	LED_print(1,'B');         // Will print "b" to digit 1, function returns 1
	LED_update();    
}


void Timer1_Init(void)
{       
	TCCR1B = (1<<CS12)| (1<<CS10); /*1024 prescaler*/
	TCCR1B |= (1<<WGM12);
	OCR1A = 4883;                  /*zählt jede 3 sekunde*/
	TCNT1=0;
	TIMSK1 |= (1<<OCIE1A);
	sprintf(tempstr, "TCCR1B: 0x%x\n",TCCR1B);
	break_point(tempstr, __LINE__);
}

void break_point(char *str, uint8_t v) 
{
	int a,b=10;
	a=b+2+v;

	return;

}